<h3>Téléversement de fichiers/images</h3>
<div id="cleared"></div>
<div id="upload_form" class="card text-center">
  <div class="card-body text-center">
    <p class="card-text" id="max_size_msg" name="max_size_msg" style="display: none;">Taille maximum autorisée : __MAXSIZE__ Mo</p>
    <form method="POST" class="upload-form" id="form_upload" action="/api/upload" enctype="multipart/form-data">
      <div class="form-group row">
        <label for="type_file" class="col-4 text-right col-form-label">Type du fichier</label>
            <div class="col-8">
              <select id="type_file" name="type_file" required="required" class="custom-select">
                <option value="qcow2">Image QCow2 (KVM)</option>
                <option value="iso">Image ISO (CDROM)</option>
                <option value="docker_image">Image Docker</option>
                <option value="lxc_image">Image LXC</option>
                <option value="lxd_image">Image LXD</option>
                <option value="yaml_archi">Fichier d'architecture, au format yaml</option>
                <option value="yaml_kvm">Fichier de description d'un machine virtuelle, au format yaml</option>
              </select>
            </div>
        </div>
        <div class="form-group row">
          <label for="file_input" class="col-4 text-right col-form-label">Fichier</label>
          <div class="col-8">
            <div class="custom-file">
              <input type="file" class="custom-file-input" name="ufile" id="file_input" accept=".qcow2" required="required">
              <label id="file_input_label" class="custom-file-label"></i>Sélectionner un fichier</label>
            </div>
          </div>
        </div>
        <div>
            <input type="hidden" id="tr" name="tr" value="__TOKEN__">
        </div>
        <div class="form-group row">
          <div class="progress">
          </div>
        </div>
        <div class="form-group row">
          <div class="offset-4 col-8">
            <a href="/admin/upload" id="cancel" name="cancel" class="btn btn-outline-secondary">Cancel</a>
            <button name="submit" type="submit" id="upload_btn" class="btn btn-primary">Téléverser</button>
          </div>
        </div>
      </form>
  </div>
</div>
<div id="uploaded_form" class="card">
  <div class="card-body">
      <div class="form-group form-inline">
          <label for="filename" class="col-lg-4 control-label">Name :</label>
          <div class="col-lg-8 text-left">
              <samp id="res_filename"></samp>
          </div>
      </div>
      <div class="form-group form-inline">
          <label for="length" class="col-lg-4 control-label">Length :</label>
          <div class="col-lg-8 text-left">
              <samp id="res_length"></samp>
          </div>
      </div>
      <div class="form-group form-inline">
          <label for="mimetype" class="col-lg-4 control-label">Mime-type :</label>
          <div class="col-lg-8 text-left">
              <samp id="res_mime"></samp>
          </div>
      </div>
      <div class="form-group form-inline">
          <label for="sha1" class="col-lg-4 control-label">SHA-1 :</label>
          <div class="col-lg-8 text-left">
              <samp id="res_sha1"></samp>
          </div>
      </div>
      <div class="form-group form-inline">
          <label for="sha256" class="col-lg-4 control-label">SHA-256 :</label>
          <div class="col-lg-8 text-left">
              <samp id="res_sha256"></samp>
          </div>
      </div>
      <fieldset id="bt_fieldset" class='actions' style="display: none;">
          <legend class='actions-border'>Actions</legend>
          <div id="buttons" class="btn-group" role="group" aria-label="Actions">
              <button id="bt_retry" class="btn btn-warning" type="button" onclick="retry()" disabled>Retry</button>
              <button id="bt_force"  class="btn btn-danger" type="button" onclick="retry_and_force()" disabled>Force</button>
          </div>
      </fieldset>
  </div>
</div>

<script>
  const uploadForm = document.querySelector('#form_upload');
  const filesInput = uploadForm.querySelector('#file_input');
  var file_input_label = document.getElementById("file_input_label");
  var original_url='/api/moveuploaded';

  $(document).ready(function () {
    maxuploadsize = __MAXSIZE__;
    if (maxuploadsize !== 0)
      $('#max_size_msg').show();
      $('#uploaded_form').hide();
  });

  $('#type_file').change(function(){
    var value = $(this).val();
    if (value=="yaml_archi" || value=="yaml_kvm")
        value=".yaml,.yml"
    else if (value=="lxc_image" || value=="lxd_image")
        value=".tar.gz"
    else if (value=="docker_image")
        value=".tar"
    else value="."+value
    $('#file_input').attr("accept", value)
  });

  // Attach onchange event handler to the files input element
  filesInput.onchange = () => {
    // Append all the file names to the label
    file_input_label.innerHTML = '';
    file_input_label.innerHTML += '<span>' + filesInput.files[0].name + '</span>';
  };

  uploadForm.onsubmit = event => {
    event.preventDefault();
    if (typeof filesInput.files !== "undefined") {
      var size = parseInt(filesInput.files[0].size);
      var limit = maxuploadsize * 1000 * 1000;
      if (maxuploadsize != 0 && size >= limit) {
        messageBoxWarning("La taille du fichier est supérieure à la taille limite");
        e.preventDefault(); // Cancel the submit
        return;
      }
    }

    // Make sure files are selected
    if (!filesInput.files.length) {
      messageBoxError('Veuillez sélectionner un fichier')
    } else {
      // Create the form object
      let uploadFormData = new FormData(uploadForm);
      // Initiate the AJAX request
      let request = new XMLHttpRequest();
      // Ensure the request method is POST
      request.open('POST', uploadForm.action);

      request.onreadystatechange = function() {
        if (this.readyState == 4) {
          if (this.status == 200 && typeof this.responseText!=='undefined') {
            var response = JSON.parse(this.responseText);
            if ("success" in response) {
              if (response["success"]) {
                $('#uploaded_form').show();
                $('#upload_form').hide();
                $("#res_filename").html(response['upload_filename']);
                $("#res_length").html(response['size']);
                $("#res_mime").html(response['content_type']);
                $("#res_sha1").html(response['sha1sum']);
                $("#res_sha256").html(response['sha256sum']);
                original_url+="?name="+response['upload_filename']+"&type="+response['type_file'];
                moveuploadedfile();
                return;
              } else {
                messageBoxError(response.msg);
                if ("tr" in response) // update token if given
                  $("#tr").val(response['tr']);
                $("#upload_btn").attr("disabled", false);
                $("#upload_btn").html('Téléverser');
                return;
              }
            }
          }
          messageBoxError("An error occured");
        }
      }
      // Attach the progress event handler to the AJAX request
      request.upload.addEventListener('progress', event => {
        // Add the current progress to the button
        uploadForm.querySelector('button').innerHTML = 'Téléversement... ' + '(' + ((event.loaded / event.total) * 100).toFixed(1) + '%)';
        // Update the progress bar
        uploadForm.querySelector('.progress').style.background = 'linear-gradient(to right, #25b350, #25b350 ' + Math.round((event.loaded / event.total) * 100) + '%, #e6e8ec ' + Math.round((event.loaded / event.total) * 100) + '%)';
        // Disable the submit button
        uploadForm.querySelector('button').disabled = true;
      });

      request.send(uploadFormData);
    }
  };


  function moveuploadedfile(force=false) {
    block();
    $.ajax({
        url: original_url+"&force="+force,
        dataType: 'json',
        }).done(function (response) {
        if (typeof response.success !== 'undefined') {
            if (response.success) {
                enableBtActions(false);
                messageBoxInfo("Terminé");
            } else {
                enableBtActions(true);
                if  (typeof response.maintenance !== 'undefined' && response.maintenance)
                    messageBoxWarning("Le système est en mode maintenance. Veuillez réessayer plus tard ...");
                else if (typeof response.dos !== 'undefined' && response.dos)
                    messageBoxWarning("Trop de requêtes. Veuillez réessayer plus tard ...");
                else if (typeof response.message !== 'undefined' && response.message)
                    messageBoxError(response.message);
                else
                    messageBoxError("Erreur lors de la tentative de transfert de fichier");
            }
            unBlock();
        }
    });
  };

  function enableBtActions(state=true) {
    $("#bt_retry").attr("disabled", ! state);
    $("#bt_force").attr("disabled", ! state);
    if (state)
        $("#bt_fieldset").show();
    else
        $("#bt_fieldset").hide();
  }

  function retry() {
    moveuploadedfile();
  };

  function retry_and_force() {
    if (confirm('Attention, si un objet existe avec le même nom, il sera irrémédiablement remplacé !'))
        moveuploadedfile(true);
  };

</script>
